#include "library/_sms_setz80stackpoint.bas"
#include "library/smsfilvrm.bas"
#include "library/smsvpoke.bas"
#include "library/smsldirvm.bas"

#include "library/smsrnd.bas"
#include "library/smsjoypad.bas"
#include "library/_smsloadtiles1bitv1.bas"
#include "library/screenfont01.bas"
#include "library/smsvdp.bas"
#include "library/smsscroll.bas"
#include "library/ggpalette.bas"
#include "library/neko_sprites_16x16c.bas"

#include "library/smswaitvbl.bas"

'- mode 1 - vdp entries for screen1 - base vram addresses
smsvdp(0,$00):smsvdp(1,$E2) '- screen1,2
smsvdp(2,$06):smsvdp(3,$80):smsvdp(4,$00)
smsvdp(5,$36):smsvdp(6,$07)
smsvdp(7,$F1) 'smsvdp(7,F*16+4) '- ink*16+border - color(3,?,1)

'- this is setting mode 4?
'smsvdp(0,%00000100):smsvdp(1,%11100000) '- smsvdp(1,$84)
'smsvdp(2,$ff):smsvdp(5,$ff):smsvdp(6,$ff):smsvdp(7,$ff):smsvdp(10,$ff)
'smsscroll($30,$c8) '- (for locating the gamegear display on the top-left edge of pattern area)

smsfilvrm($0000,0,$4000) '- replaces "clear vram"
smsfilvrm($2000,$1F,$1800)

dim eee as uinteger at $C010
dim ee0 as uinteger at $C012
dim ee1 as uinteger at $C014
dim ee2 as uinteger at $C016
dim ee3 as uinteger at $C018
dim ee4 as uinteger at $C01A
dim ee5 as uinteger at $C01C
dim ee6 as uinteger at $C01E
dim ee7 as uinteger at $C020
dim cntr as uinteger at $C022
dim eesd as uinteger at $C024
dim rxpos as integer at $C026
dim rypos as integer at $C028
dim cxpos as integer at $C02A
dim cypos as integer at $C02C
dim catstate as integer at $C02E
dim ratstate as integer at $C030
dim eejp as ubyte at $C032
dim eecnt as byte at $C033
dim jacum as ubyte at $C034
dim cdirh as ubyte at $C035
dim cdirv as ubyte at $C036
dim cdirrt as ubyte at $C037
dim wallht as ubyte at $C038


sub putnekosprite(tlay5 as uinteger,txpos5 as ubyte,typos5 as ubyte,tnum5 as uinteger)
    smsvpoke($1B00+(8*tlay5),typos5)
    smsvpoke($1B01+(8*tlay5),txpos5)
    smsvpoke($1B02+(8*tlay5),(tnum5*4)+128)
    smsvpoke($1B03+(8*tlay5),15)
    smsvpoke($1B04+(8*tlay5),typos5)
    smsvpoke($1B05+(8*tlay5),txpos5)
    smsvpoke($1B06+(8*tlay5),(tnum5*4))
    smsvpoke($1B07+(8*tlay5),1)

  end sub


for ee1=0 to 64 step 4
  ggpalettergb(ee1+0,$000)
  ggpalettergb(ee1+1,$000)
  ggpalettergb(ee1+2,$FFF)
  ggpalettergb(ee1+3,$FFF)
  next

'------------------------------------------

eesd=0
for ee1=0 to $3FFF
  eesd=smsrnd(eesd)
  smsvpoke(ee1,eesd)
  next

smsfilvrm($0000,$FF,$4000)

'smsfilvrm($0000,$55,$0800)
smsvpoke($0000,%01110111)
smsvpoke($0001,%11111111)
smsvpoke($0002,%11011101)
smsvpoke($0003,%11111111)
smsvpoke($0004,%01110111)
smsvpoke($0005,%11111111)
smsvpoke($0006,%11011101)
smsvpoke($0007,%11111111)

smsfilvrm($0000,$FF,8)

smsvpoke($0008,%01010101)
smsvpoke($0009,%10101010)
smsvpoke($000a,%01010101)
smsvpoke($000b,%10101010)
smsvpoke($000c,%01010101)
smsvpoke($000d,%10101010)
smsvpoke($000e,%01010101)
smsvpoke($000f,%10101010)

for ee1=$1800 to $1AFF
  smsvpoke(ee1,$01)
  next

for ee2=3 to 20
  for ee1=0 to 19
    smsvpoke($1806+ee2*32+ee1,$00)
    next:next

smsldirvm($3800,@bin01,2048)

smsfilvrm($1B00,0,$0400)

loopqq2:

cntr=0
rxpos=96:rypos=96
cxpos=116*2:cypos=116*2

do

ee3=(cntr mod 176)+32
ee2=((cntr/176)mod 32)*4

cntr=cntr+1
smswaitvbl(1)

cdirv=1:cdirh=1
if (cxpos/2)>rxpos then
  cxpos=cxpos-1:cdirh=0:end if
if (cxpos/2)<rxpos then
  cxpos=cxpos+1:cdirh=2:end if
if (cypos/2)>rypos then
  cypos=cypos-1:cdirv=0:end if
if (cypos/2)<rypos then
  cypos=cypos+1:cdirv=2:end if
cdirrt=peek(@rotref01+cdirv*3+cdirh)


  eejp=smsjoypad1()
  if (eejp band 1)<>0 then:rypos=rypos-1:end if
  if (eejp band 2)<>0 then:rypos=rypos+1:end if
  if (eejp band 4)<>0 then:rxpos=rxpos-1:end if
  if (eejp band 8)<>0 then:rxpos=rxpos+1:end if

if rxpos<48 then
  rxpos=48:end if
if rxpos>200 then
  rxpos=200:end if
if rypos<24 then
  rypos=24:end if
if rypos>160 then
  rypos=160:end if

wallht=7
if rxpos<56 then
  wallht=3:end if
if rxpos>192 then
  wallht=1:end if
if rypos<32 then
  wallht=0:end if
if rypos>154 then
  wallht=2:end if




putnekosprite(1,rxpos,rypos,31)

if cdirrt<8 then
  putnekosprite(0,cxpos/2,cypos/2,cdirrt*2+((cntr/8) mod 2))
  end if

if cdirrt=8 then
  if wallht<7 then
    putnekosprite(0,cxpos/2,cypos/2,16+wallht*2+((cntr/8) mod 2))
  else
    putnekosprite(0,cxpos/2,cypos/2,cdirrt*2+((cntr/8) mod 2))
    end if
  end if


  loop

'------------------------------------------
do:loop

rotref01:
asm
  defb 7,0,1,6,8,2,5,4,3
end asm

' 701
' 682
' 543



'------------------------------------------
'------------------------------------------
'------------------------------------------
'------------------------------------------
'------------------------------------------

do:loop

text01:
asm
  defb "h@e@l@l@o@ @w@o@r@l@d@!@"
  end asm
text01end:
